<template>
<div>
    <div class="row inbox-wrapper">
        <!-- left wrapper start -->
        <!-- left wrapper end -->
        <!-- middle wrapper start -->
        <div class="col-md-12 col-xl-12 middle-wrapper">
            <div class="row">
                <div class="col-md-12 grid-margin">
                    <div class="card rounded">
                        <div class="card-header">
                            <div class="d-flex align-items-center justify-content-between">
                                <div class="d-flex align-items-center">
                                    <div class="ml-2">
                                        <p>Data Inovasi Daerah</p>
                                        <p class="tx-11 text-muted">List Inovasi Daerah</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="row align-items-center">
                                <div class="col-md-6 grid-margin">
                                <div class="form-inline">
                                    <label class="mr-2">Pencarian</label>
                                    <input
                                    type="text"
                                    placeholder="Ketikan pencarian disini"
                                    class="form-control"
                                    v-model="filter"
                                    />
                                </div>
                                </div>
                                <div class="col-md-6 grid-margin">
                                <div class="form-inline float-right">
                                    <label class="mr-2">Lihat</label>
                                    <select class="form-control" v-model="per_page">
                                    <option value="10">10</option>
                                    <option value="25">25</option>
                                    <option value="50">50</option>
                                    <option value="100">100</option>
                                    </select>
                                    <label class="ml-2">Entri</label>
                                </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="table-responsive col-md-12">
                                    <b-table
                                        id="data-table"
                                        responsive
                                        hover
                                        :filter="filter"
                                        :items="dataList"
                                        :fields="fields"
                                        :per-page="per_page"
                                        :current-page="current_page"
                                        :sort-by="sortBy"
                                        :sort-desc="sortDesc"
                                        @filtered="onFiltered"
                                        show-empty
                                        :busy="isBusy"
                                    >
                                        <template v-slot:table-busy>
                                            <div class="text-center text-danger my-2">
                                                <b-spinner class="align-middle"></b-spinner>
                                                <strong>Loading...</strong>
                                            </div>
                                        </template>


                                        <template v-slot:cell(index)="row">
                                                {{(row.index+1)+(per_page*(current_page-1))}}
                                        </template>
                                        <template v-slot:cell(workshop)="row">
                                                <span v-if="row.item.workshop==='0'|| row.item.workshop===''">Tidak Ikut</span>
                                                <span v-if="row.item.workshop==='1'">Workshop I</span>
                                                <span v-if="row.item.workshop==='2'">Workshop II</span>
                                                <span v-if="row.item.workshop==='12'">Workshop I & II</span>
                                        </template>
                                        <template v-slot:cell(owner)="row">
                                                {{row.item}}
                                        </template>
                                        <template v-slot:cell(status)="row">
                                            <div v-if="(row.item.status=='pending')">
                                                 <button type="button" class="btn btn-secondary">
                                                    Pending
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='proses')">
                                                 <button type="button" class="btn btn-info">
                                                    Proses
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='approve')">
                                                 <button type="button" class="btn btn-success">
                                                    Approve
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='revisi')">
                                                 <button type="button" class="btn btn-warning">
                                                    Revisi
                                                </button>
                                            </div>
                                        </template>
                                        <template v-slot:cell(tahapan_inovasi_id)="row">
                                            <div class="form-check" v-for="(tahapan_inovasi,index) in tahapaninovasi" :key="index">
                                                <div v-if="tahapan_inovasi.id === row.item.tahapan_inovasi_id">
                                                    {{ tahapan_inovasi.name }}
                                                </div>
                                            </div>
                                        </template>
                                        <template v-slot:cell(actions)="row">

                                            <button type="button" class="btn btn-primary" @click="preview(row.item)">
                                                <b-icon icon="printer">Print Preview</b-icon>
                                                <!-- Print Preview -->
                                            </button>

                                            <button type="button" class="btn btn-primary" @click="edit(row.item)">
                                                view
                                            </button>

                                        </template>
                                    </b-table>
                                </div>
                                <div class="col-md-12">
                                    <b-pagination
                                        v-model="current_page"
                                        :total-rows="total_rows"
                                        :per-page="per_page"
                                        align="right"
                                        aria-controls="data-table"
                                    ></b-pagination>
                                </div>
                            </div>
                        </div>
                        <!-- <div class="card-footer">
                            <button class="btn btn-primary mb-1 mb-md-0" type="submit" name="action" @click.prevent="addMatkul">Select
                                <i class="mdi mdi-send"></i>
                            </button>
                        </div> -->
                    </div>
                </div>
            </div>
        </div>
        <!-- middle wrapper end -->
        <!-- right wrapper start -->
        <!-- right wrapper end -->
    </div>

</div>
</template>

<script>

export default {
    components: {  },
    props:['datakrs'],
    data() {
         return {
            url:'getdata',
            name:'table',
            emptyResult: false,
            dataList: [],
            totalSKS:0,
            current_page: 1,
            per_page: 10,
            filter: null,
            sortDesc: false,
            sortBy: "index",
            fields: [
                { key: "index", sortable: false, label: "#" },
                { key: "nama_singkat", sortable: false, label: "Nama Inovasi" },
                { key: "tahapan_inovasi_id", sortable: false, label: "Tahapan" },
                { key: "waktu_implementasi", sortable: false, label: "Waktu Penerapan" },
                { key: "status", sortable: false, label: "Status"},
                { key: "actions", label: "Action" },
            ],
            total_rows: 0,
            dataBentrok : {},
            isBusy:true,
            json_fields: {
                'ID': 'id',
                'Fullname': 'innovator',
                'Institusi': 'institusi',
                'Telephone': 'phone',
                'Email': 'email',
                'Workshop' : {
                    field: 'workshop',
                    callback: (value) => {
                        if(value==='0' || ''){
                          return "Tidak Ikut";
                        }
                        if(value==='1'){
                          return "Workshop I";
                        }
                        if(value==='2'){
                          return "Workshop II";
                        }
                        if(value==='12'){
                          return "Workshop I & II";
                        }
                    }
                  },
                'Biaya Workshop': 'biaya_workshop',
                'Symposium': 'symposium',
                'Biaya Symposium': 'biaya_symposium',
                'Total': 'total',
                'Tanggal Konfirmasi': 'created_at'
                // 'Payment' : {
                //     field: 'payment',
                //     callback: (value) => {
                //         return (value===1)?"Sudah Bayar":"Belum Bayar";
                //     }
                //   },
            },
            json_meta: [
                [
                    {
                        'key': 'charset',
                        'value': 'utf-8'
                    }
                ]
            ],
            tahapaninovasi:[],

        }

    },

    created(){
        // this.initial()
        this.getData()
        this.getTahapanInovasi()

    },
    methods:{
        // initial(){

        // },
        async getData() {
            let self = this
            let ulrlist = `${this.url}`
            this.dataList = await axios.get(ulrlist).then((response)=> {
                this.isBusy = false
                return response.data
            })
            this.total_rows =  this.dataList.length
        },
        getTahapanInovasi() {
            let url = 'get/tahapaninovasi'
            axios.get(url).then(response => {
                this.tahapaninovasi = response.data
            })
        },
        onFiltered(filteredItems) {
          // Trigger pagination to update the number of buttons/pages due to filtering
          this.total_rows = filteredItems.length;
          this.current_page = 1;
        },

        //preview from vue table
        preview(data){
            this.toEdit('PreviewInovasi',data)
        },

        //edit from vue table
        edit(data){
            this.toEdit('AddInovasi',data)
        },

        toEdit(action,data){
            let dataEmit = {
                visit : action,
                data : data,
                back : this.component,
            }
            this.$emit('datacomponent', dataEmit)
        },
    }
}
</script>
<style>
</style
